# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['ElasticSearchAclRuleArgs', 'ElasticSearchAclRule']

@pulumi.input_type
class ElasticSearchAclRuleArgs:
    def __init__(__self__, *,
                 index: pulumi.Input[str],
                 permission: pulumi.Input[str],
                 project: pulumi.Input[str],
                 service_name: pulumi.Input[str],
                 username: pulumi.Input[str]):
        """
        The set of arguments for constructing a ElasticSearchAclRule resource.
        :param pulumi.Input[str] index: Elasticsearch index pattern
        :param pulumi.Input[str] permission: is the Elasticsearch permission, list of supported permissions: 
               `deny`, `admin`, `read`, `readwrite`, `write`.
        :param pulumi.Input[str] project: and `service_name` - (Required) define the project and service the ACL belongs to.
        :param pulumi.Input[str] service_name: Service to link the Elasticsearch ACLs to
        :param pulumi.Input[str] username: and `index` - (Required) define the username and index the ACL rule should apply to.
        """
        pulumi.set(__self__, "index", index)
        pulumi.set(__self__, "permission", permission)
        pulumi.set(__self__, "project", project)
        pulumi.set(__self__, "service_name", service_name)
        pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter
    def index(self) -> pulumi.Input[str]:
        """
        Elasticsearch index pattern
        """
        return pulumi.get(self, "index")

    @index.setter
    def index(self, value: pulumi.Input[str]):
        pulumi.set(self, "index", value)

    @property
    @pulumi.getter
    def permission(self) -> pulumi.Input[str]:
        """
        is the Elasticsearch permission, list of supported permissions: 
        `deny`, `admin`, `read`, `readwrite`, `write`.
        """
        return pulumi.get(self, "permission")

    @permission.setter
    def permission(self, value: pulumi.Input[str]):
        pulumi.set(self, "permission", value)

    @property
    @pulumi.getter
    def project(self) -> pulumi.Input[str]:
        """
        and `service_name` - (Required) define the project and service the ACL belongs to.
        """
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: pulumi.Input[str]):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> pulumi.Input[str]:
        """
        Service to link the Elasticsearch ACLs to
        """
        return pulumi.get(self, "service_name")

    @service_name.setter
    def service_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "service_name", value)

    @property
    @pulumi.getter
    def username(self) -> pulumi.Input[str]:
        """
        and `index` - (Required) define the username and index the ACL rule should apply to.
        """
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: pulumi.Input[str]):
        pulumi.set(self, "username", value)


@pulumi.input_type
class _ElasticSearchAclRuleState:
    def __init__(__self__, *,
                 index: Optional[pulumi.Input[str]] = None,
                 permission: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 service_name: Optional[pulumi.Input[str]] = None,
                 username: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ElasticSearchAclRule resources.
        :param pulumi.Input[str] index: Elasticsearch index pattern
        :param pulumi.Input[str] permission: is the Elasticsearch permission, list of supported permissions: 
               `deny`, `admin`, `read`, `readwrite`, `write`.
        :param pulumi.Input[str] project: and `service_name` - (Required) define the project and service the ACL belongs to.
        :param pulumi.Input[str] service_name: Service to link the Elasticsearch ACLs to
        :param pulumi.Input[str] username: and `index` - (Required) define the username and index the ACL rule should apply to.
        """
        if index is not None:
            pulumi.set(__self__, "index", index)
        if permission is not None:
            pulumi.set(__self__, "permission", permission)
        if project is not None:
            pulumi.set(__self__, "project", project)
        if service_name is not None:
            pulumi.set(__self__, "service_name", service_name)
        if username is not None:
            pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter
    def index(self) -> Optional[pulumi.Input[str]]:
        """
        Elasticsearch index pattern
        """
        return pulumi.get(self, "index")

    @index.setter
    def index(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "index", value)

    @property
    @pulumi.getter
    def permission(self) -> Optional[pulumi.Input[str]]:
        """
        is the Elasticsearch permission, list of supported permissions: 
        `deny`, `admin`, `read`, `readwrite`, `write`.
        """
        return pulumi.get(self, "permission")

    @permission.setter
    def permission(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "permission", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input[str]]:
        """
        and `service_name` - (Required) define the project and service the ACL belongs to.
        """
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> Optional[pulumi.Input[str]]:
        """
        Service to link the Elasticsearch ACLs to
        """
        return pulumi.get(self, "service_name")

    @service_name.setter
    def service_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_name", value)

    @property
    @pulumi.getter
    def username(self) -> Optional[pulumi.Input[str]]:
        """
        and `index` - (Required) define the username and index the ACL rule should apply to.
        """
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "username", value)


class ElasticSearchAclRule(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 index: Optional[pulumi.Input[str]] = None,
                 permission: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 service_name: Optional[pulumi.Input[str]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        ## # Elasticsearch ACL Rule Resource

        The Elasticsearch ACL Rule resource models a single ACL Rule for an Aiven Elasticsearch service.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_aiven as aiven

        es_user = aiven.ServiceUser("esUser",
            project=var["aiven_project_name"],
            service_name=aiven_elasticsearch["es_test"]["service_name"],
            username="documentation-user-1")
        es_user2 = aiven.ServiceUser("esUser2",
            project=var["aiven_project_name"],
            service_name=aiven_elasticsearch["es_test"]["service_name"],
            username="documentation-user-2")
        es_acls_config = aiven.ElasticSearchAclConfig("esAclsConfig",
            project=var["aiven_project_name"],
            service_name=aiven_elasticsearch["es_test"]["service_name"],
            enabled=True,
            extended_acl=False)
        acl_rules = [
            {
                "username": es_user.username,
                "index": "index2",
                "permission": "readwrite",
            },
            {
                "username": es_user.username,
                "index": "index3",
                "permission": "read",
            },
            {
                "username": es_user.username,
                "index": "index5",
                "permission": "deny",
            },
            {
                "username": es_user2.username,
                "index": "index3",
                "permission": "write",
            },
            {
                "username": es_user2.username,
                "index": "index7",
                "permission": "readwrite",
            },
        ]
        es_acl_rule = []
        for range in [{"key": k, "value": v} for [k, v] in enumerate({i: v for i, v in acl_rules})]:
            es_acl_rule.append(aiven.ElasticSearchAclRule(f"esAclRule-{range['key']}",
                project=es_acls_config.project,
                service_name=es_acls_config.service_name,
                username=range["value"]["username"],
                index=range["value"]["index"],
                permission=range["value"]["permission"]))
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] index: Elasticsearch index pattern
        :param pulumi.Input[str] permission: is the Elasticsearch permission, list of supported permissions: 
               `deny`, `admin`, `read`, `readwrite`, `write`.
        :param pulumi.Input[str] project: and `service_name` - (Required) define the project and service the ACL belongs to.
        :param pulumi.Input[str] service_name: Service to link the Elasticsearch ACLs to
        :param pulumi.Input[str] username: and `index` - (Required) define the username and index the ACL rule should apply to.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ElasticSearchAclRuleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## # Elasticsearch ACL Rule Resource

        The Elasticsearch ACL Rule resource models a single ACL Rule for an Aiven Elasticsearch service.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_aiven as aiven

        es_user = aiven.ServiceUser("esUser",
            project=var["aiven_project_name"],
            service_name=aiven_elasticsearch["es_test"]["service_name"],
            username="documentation-user-1")
        es_user2 = aiven.ServiceUser("esUser2",
            project=var["aiven_project_name"],
            service_name=aiven_elasticsearch["es_test"]["service_name"],
            username="documentation-user-2")
        es_acls_config = aiven.ElasticSearchAclConfig("esAclsConfig",
            project=var["aiven_project_name"],
            service_name=aiven_elasticsearch["es_test"]["service_name"],
            enabled=True,
            extended_acl=False)
        acl_rules = [
            {
                "username": es_user.username,
                "index": "index2",
                "permission": "readwrite",
            },
            {
                "username": es_user.username,
                "index": "index3",
                "permission": "read",
            },
            {
                "username": es_user.username,
                "index": "index5",
                "permission": "deny",
            },
            {
                "username": es_user2.username,
                "index": "index3",
                "permission": "write",
            },
            {
                "username": es_user2.username,
                "index": "index7",
                "permission": "readwrite",
            },
        ]
        es_acl_rule = []
        for range in [{"key": k, "value": v} for [k, v] in enumerate({i: v for i, v in acl_rules})]:
            es_acl_rule.append(aiven.ElasticSearchAclRule(f"esAclRule-{range['key']}",
                project=es_acls_config.project,
                service_name=es_acls_config.service_name,
                username=range["value"]["username"],
                index=range["value"]["index"],
                permission=range["value"]["permission"]))
        ```

        :param str resource_name: The name of the resource.
        :param ElasticSearchAclRuleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ElasticSearchAclRuleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 index: Optional[pulumi.Input[str]] = None,
                 permission: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 service_name: Optional[pulumi.Input[str]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ElasticSearchAclRuleArgs.__new__(ElasticSearchAclRuleArgs)

            if index is None and not opts.urn:
                raise TypeError("Missing required property 'index'")
            __props__.__dict__["index"] = index
            if permission is None and not opts.urn:
                raise TypeError("Missing required property 'permission'")
            __props__.__dict__["permission"] = permission
            if project is None and not opts.urn:
                raise TypeError("Missing required property 'project'")
            __props__.__dict__["project"] = project
            if service_name is None and not opts.urn:
                raise TypeError("Missing required property 'service_name'")
            __props__.__dict__["service_name"] = service_name
            if username is None and not opts.urn:
                raise TypeError("Missing required property 'username'")
            __props__.__dict__["username"] = username
        super(ElasticSearchAclRule, __self__).__init__(
            'aiven:index/elasticSearchAclRule:ElasticSearchAclRule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            index: Optional[pulumi.Input[str]] = None,
            permission: Optional[pulumi.Input[str]] = None,
            project: Optional[pulumi.Input[str]] = None,
            service_name: Optional[pulumi.Input[str]] = None,
            username: Optional[pulumi.Input[str]] = None) -> 'ElasticSearchAclRule':
        """
        Get an existing ElasticSearchAclRule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] index: Elasticsearch index pattern
        :param pulumi.Input[str] permission: is the Elasticsearch permission, list of supported permissions: 
               `deny`, `admin`, `read`, `readwrite`, `write`.
        :param pulumi.Input[str] project: and `service_name` - (Required) define the project and service the ACL belongs to.
        :param pulumi.Input[str] service_name: Service to link the Elasticsearch ACLs to
        :param pulumi.Input[str] username: and `index` - (Required) define the username and index the ACL rule should apply to.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ElasticSearchAclRuleState.__new__(_ElasticSearchAclRuleState)

        __props__.__dict__["index"] = index
        __props__.__dict__["permission"] = permission
        __props__.__dict__["project"] = project
        __props__.__dict__["service_name"] = service_name
        __props__.__dict__["username"] = username
        return ElasticSearchAclRule(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def index(self) -> pulumi.Output[str]:
        """
        Elasticsearch index pattern
        """
        return pulumi.get(self, "index")

    @property
    @pulumi.getter
    def permission(self) -> pulumi.Output[str]:
        """
        is the Elasticsearch permission, list of supported permissions: 
        `deny`, `admin`, `read`, `readwrite`, `write`.
        """
        return pulumi.get(self, "permission")

    @property
    @pulumi.getter
    def project(self) -> pulumi.Output[str]:
        """
        and `service_name` - (Required) define the project and service the ACL belongs to.
        """
        return pulumi.get(self, "project")

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> pulumi.Output[str]:
        """
        Service to link the Elasticsearch ACLs to
        """
        return pulumi.get(self, "service_name")

    @property
    @pulumi.getter
    def username(self) -> pulumi.Output[str]:
        """
        and `index` - (Required) define the username and index the ACL rule should apply to.
        """
        return pulumi.get(self, "username")

