# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetAccountResult',
    'AwaitableGetAccountResult',
    'get_account',
    'get_account_output',
]

@pulumi.output_type
class GetAccountResult:
    """
    A collection of values returned by getAccount.
    """
    def __init__(__self__, account_id=None, create_time=None, id=None, name=None, owner_team_id=None, tenant_id=None, update_time=None):
        if account_id and not isinstance(account_id, str):
            raise TypeError("Expected argument 'account_id' to be a str")
        pulumi.set(__self__, "account_id", account_id)
        if create_time and not isinstance(create_time, str):
            raise TypeError("Expected argument 'create_time' to be a str")
        pulumi.set(__self__, "create_time", create_time)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if owner_team_id and not isinstance(owner_team_id, str):
            raise TypeError("Expected argument 'owner_team_id' to be a str")
        pulumi.set(__self__, "owner_team_id", owner_team_id)
        if tenant_id and not isinstance(tenant_id, str):
            raise TypeError("Expected argument 'tenant_id' to be a str")
        pulumi.set(__self__, "tenant_id", tenant_id)
        if update_time and not isinstance(update_time, str):
            raise TypeError("Expected argument 'update_time' to be a str")
        pulumi.set(__self__, "update_time", update_time)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> str:
        """
        is an auto-generated unique account id.
        """
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        time of creation.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="ownerTeamId")
    def owner_team_id(self) -> str:
        """
        is an owner team id.
        """
        return pulumi.get(self, "owner_team_id")

    @property
    @pulumi.getter(name="tenantId")
    def tenant_id(self) -> str:
        """
        is a tenant id.
        """
        return pulumi.get(self, "tenant_id")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> str:
        """
        time of last update.
        """
        return pulumi.get(self, "update_time")


class AwaitableGetAccountResult(GetAccountResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAccountResult(
            account_id=self.account_id,
            create_time=self.create_time,
            id=self.id,
            name=self.name,
            owner_team_id=self.owner_team_id,
            tenant_id=self.tenant_id,
            update_time=self.update_time)


def get_account(account_id: Optional[str] = None,
                create_time: Optional[str] = None,
                name: Optional[str] = None,
                owner_team_id: Optional[str] = None,
                tenant_id: Optional[str] = None,
                update_time: Optional[str] = None,
                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAccountResult:
    """
    ## # Account Data Source

    The Account data source provides information about the existing Aiven Account.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_aiven as aiven

    account1 = aiven.get_account(name="<ACCOUNT_NAME>")
    ```


    :param str account_id: is an auto-generated unique account id.
    :param str create_time: time of creation.
    :param str name: defines an account name.
    :param str owner_team_id: is an owner team id.
    :param str tenant_id: is a tenant id.
    :param str update_time: time of last update.
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    __args__['createTime'] = create_time
    __args__['name'] = name
    __args__['ownerTeamId'] = owner_team_id
    __args__['tenantId'] = tenant_id
    __args__['updateTime'] = update_time
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('aiven:index/getAccount:getAccount', __args__, opts=opts, typ=GetAccountResult).value

    return AwaitableGetAccountResult(
        account_id=__ret__.account_id,
        create_time=__ret__.create_time,
        id=__ret__.id,
        name=__ret__.name,
        owner_team_id=__ret__.owner_team_id,
        tenant_id=__ret__.tenant_id,
        update_time=__ret__.update_time)


@_utilities.lift_output_func(get_account)
def get_account_output(account_id: Optional[pulumi.Input[Optional[str]]] = None,
                       create_time: Optional[pulumi.Input[Optional[str]]] = None,
                       name: Optional[pulumi.Input[str]] = None,
                       owner_team_id: Optional[pulumi.Input[Optional[str]]] = None,
                       tenant_id: Optional[pulumi.Input[Optional[str]]] = None,
                       update_time: Optional[pulumi.Input[Optional[str]]] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAccountResult]:
    """
    ## # Account Data Source

    The Account data source provides information about the existing Aiven Account.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_aiven as aiven

    account1 = aiven.get_account(name="<ACCOUNT_NAME>")
    ```


    :param str account_id: is an auto-generated unique account id.
    :param str create_time: time of creation.
    :param str name: defines an account name.
    :param str owner_team_id: is an owner team id.
    :param str tenant_id: is a tenant id.
    :param str update_time: time of last update.
    """
    ...
